import Vue from 'vue'
import App from './App'
import store from './store'
import b2Loading from './components/loading.vue'
import b2swiper from './components/swiper.vue' //幻灯
import noticeBar from './components/uni-notice-bar/uni-notice-bar.vue' //公告
import b2circle from './components/circle.vue' //圈子
import b2collection from './components/collection.vue' //专题
import b2font from './components/b2font.vue' //图标字体
import b2menu from './components/menu.vue' //菜单
import b2product from './components/product.vue' //图标字体
import b2document from './components/document.vue' //首页文档模块
import b2post from './components/post.vue' //首页文档模块
import b2newsflashes from './components/newsflashes.vue' //首页文档模块
import b2topic from './components/topic.vue' //帖子
import b2timage from './components/circle/image.vue' //帖子图片
import b2video from './components/circle/video.vue' //帖子视频
import b2file from './components/circle/file.vue' //帖子文件
import b2card from './components/circle/card.vue' //帖子文件
import commentbar from './components/commentbar.vue' //帖子文件
import sk from './components/sk.vue' //帖子文件
import commentlist from './components/commentlist.vue' //帖子文件
import comment from './components/comment.vue' //帖子文件
import commentItem from './components/commentItem.vue' //帖子文件
import b2toolbar from './components/toolbar.vue' //底部导航条
import b2stream from './components/stream.vue' //动态
import streamIndex from './components/streamIndex.vue' //动态
import collectionIndex from './components/collectionIndex.vue'
import b2jubao from './components/jubao.vue' //动态
// import b2content from './components/content.vue'//内容块
// import b2scroll from './components/scroll.vue'//内容块

import b2bottom from './components/bottom.vue' //页面底部按钮
import b2download from './components/download.vue' //下载
import b2videos from './components/videos.vue' //视频模块
import b2creditPay from './components/creditPay.vue' //积分支付
import b2gold from './components/gold.vue' //财富列表
import lodingtop from './components/lodingtop.vue'
import loadingBottom from './components/loadingBottom.vue'

import singleBar from './components/singleBar.vue'

Vue.component('b2jubao', b2jubao)
Vue.component('b2Loading', b2Loading)
Vue.component('b2swiper', b2swiper)
Vue.component('noticeBar', noticeBar)
Vue.component('b2circle', b2circle)
Vue.component('b2font', b2font)
Vue.component('b2menu', b2menu)
Vue.component('b2collection', b2collection)
Vue.component('b2product', b2product)
Vue.component('b2document', b2document)
Vue.component('b2post', b2post)
Vue.component('b2newsflashes', b2newsflashes)
Vue.component('b2topic', b2topic)
Vue.component('b2timage', b2timage)
Vue.component('b2video', b2video)
Vue.component('b2file', b2file)
Vue.component('b2card', b2card)
Vue.component('b2commentbar', commentbar)
Vue.component('comment', comment)
Vue.component('commentItem', commentItem)
Vue.component('sk', sk)
Vue.component('commentlist', commentlist)
Vue.component('b2toolbar', b2toolbar)
Vue.component('b2stream', b2stream)
// Vue.component('b2content',b2content)
Vue.component('b2download', b2download)

// Vue.component('b2scroll',b2scroll)

Vue.component('b2bottom', b2bottom)
Vue.component('b2videos', b2videos)

Vue.component('b2creditPay', b2creditPay)
Vue.component('b2gold', b2gold)

Vue.component('lodingtop', lodingtop)
Vue.component('loadingBottom', loadingBottom)

Vue.component('singleBar', singleBar)

Vue.component('streamIndex', streamIndex)
Vue.component('collectionIndex', collectionIndex)

Vue.config.productionTip = false
Vue.prototype.$store = store

// import http from './pages/utils/request.js'

// Vue.prototype.$http=http

App.mpType = 'app'

Vue.prototype.go = function(url) {

	if ((url == '/my/vips' || url == '/my/gold') && !this.$store.state.token) {
		uni.navigateTo({
			url: '/global/login'
		})
		return
	}

	// #ifdef APP-PLUS
	if (url == '/global/login' && this.$store.state.univerify.open) {

		// #ifndef MP-BAIDU
		uni.login({
			provider: 'univerify',
			univerifyStyle: {
				"fullScreen": false,
				"privacyTerms": {
					"defaultCheckBoxState": false
				}
			},
			success: (res) => { // 登录成功

				uni.request({
					method: "post",
					url: this.$store.state.restUrl + 'phoneLogin',
					data: {
						access_token: res.authResult.access_token,
						openid: res.authResult.openid
					},
					success: (_res) => {
						console.log(_res)
						if (_res.statusCode != 403) {
							this.$store.commit('setToken', _res.data.token)
							this.$store.commit('setUserData', _res.data)
							this.$store.state.reflash = true
							uni.closeAuthView()
						} else {
							uni.showModal({
								content: typeof(_res.data.message) === 'string' ?
									_res.data.message : _res.data.message.error
									.message,
								showCancel: false
							})
							uni.closeAuthView()

						}
						uni.hideLoading()
					},
					fail: (res) => {
						uni.showModal({
							content: typeof(res.data.message) === 'string' ? res
								.data.message : res.data.message.error.message,
							showCancel: false
						})

						uni.hideLoading()

						uni.closeAuthView()
					}
				});
			},
			fail: (res) => { // 登录失败
				if (res.errCode == 30002) {

					uni.navigateTo({
						url: '/global/login'
					})
				}
				uni.closeAuthView()
				console.log(res)
				uni.hideLoading()
			}
		})
		// #endif


	} else {
		uni.navigateTo({
			url: url
		})
	}
	// #endif

	// #ifndef APP-PLUS
	uni.navigateTo({
		url: url
	})
	return
	// #endif
};

Vue.prototype.currentUrl = function() {
	const route = this.$mp.page.route
	const options = this.$mp.page.options

	const p = Object.keys(options).length > 0 ? '?' + this.formateObjToParamStr(options) : ''
	return '/' + this.$mp.page.route + p
}

Vue.prototype.gotab = function(url) {
	uni.switchTab({
		url: url
	});
};

Vue.prototype.goback = function(url) {
	const pages = getCurrentPages();

	if (pages.length === 2) {
		uni.navigateBack({
			delta: 1
		});
	} else if (pages.length === 1) {
		uni.switchTab({
			url: '/pages/index/index',
		})
	} else {
		uni.navigateBack({
			delta: 1
		});
	}
};

Vue.prototype.getCaption = function(str) {

	let index = str.lastIndexOf("/");
	str = str.substring(index + 1, str.length);
	return str;
}

Vue.prototype.socialLogin = function(type, userInfo) {
	return new Promise((resolve, reject) => {
		uni.getProvider({
			service: 'oauth',
			success: (res) => {

				if (res.provider.indexOf(type) != -1) {
					// #ifndef APP-PLUS
					uni.showLoading({
						title: '登录中...'
					});
					// #endif
					
					// #ifndef MP-BAIDU
					uni.login({
						provider: type == 'weibo' ? 'sinaweibo' : type,
						success: (loginRes) => {
						console.log(loginRes)
							// #ifdef APP-PLUS
							Object.assign(loginRes.authResult, {
								'type': type
							})
							
							uni.request({
								method: "POST",
								url: this.$store.state.restUrl +
									'socialLogin',
								data: loginRes.authResult,
								header: this.$store.state.headerToken,
								success: (res) => {
									uni.hideLoading();
									if (res.statusCode == 403) {
										uni.showModal({
											content: res.data
												.message.msg ?
												res.data.message
												.msg : res.data
												.message,
											showCancel: false
										})
									} else {
										resolve(res)
									}
								},
								fail: (err) => {
									console.log(err)
									uni.hideLoading()
								}
							});
							// #endif

							// #ifdef MP-WEIXIN
							uni.request({
								method: "POST",
								url: this.$store.state.restUrl +
									'getMPweixinOpenid',
								header: this.$store.state.headerToken,
								data: {
									code: loginRes.code
								},
								success: (res) => {

									if (res.statusCode == 403) {
										uni.hideLoading();
										uni.showModal({
											content: res.data
												.message,
											showCancel: false
										})
									} else {

										let data = res.data
										data.type = 'weixin'
										if (userInfo) {
											data.user_info = userInfo
										}
										data.mpweixin = true
										uni.request({
											method: "POST",
											url: this.$store
												.state.restUrl +
												'socialLogin',
											data: data,
											header: this.$store
												.state
												.headerToken,
											success: (res) => {
												uni.hideLoading();
												//console.log(res)
												if (res.statusCode == 403) {
													uni.showModal({
														content: res
															.data
															.message,
														showCancel: false
													})
												} else {
													resolve(res)
												}
											}
										});
									}
									
									// uni.hideLoading();
								}
							});
							// #endif
						}
					});
					// #endif

				}
			}
		});
	})
}

let locked = false

const showToast = (title) => {
	uni.showToast({
		title: title,
		icon: 'none'
	})
}

Vue.prototype.voteAction = function(id, type) {

	if (locked == true) return
	locked = true

	if (!this.$store.state.token) {
		this.go('/global/login')
		locked = false
		return
	}



	return new Promise((resolve, reject) => {

		uni.request({
			method: "post",
			url: this.$store.state.restUrlNormal + 'postVote',
			header: this.$store.state.headerToken,
			data: {
				post_id: id,
				type: type
			},
			success: (res) => {

				if (res.statusCode == '403') {
					showToast(res.data.message)
				} else {
					if (res.data) {
						uni.showToast({
							title: '感谢您的参与',
							duration: 500
						});
						resolve(res.data)
					} else {
						showToast('请先登录')
					}

				}

				locked = false
				return
			},
			fail: (res) => {
				console.log(res.data.message)
				locked = false
			}
		})

	})
}

var checkTime = function(i) {

	if (i < 10) {

		i = "0" + i;

	}

	return i;

}

Vue.prototype.showtime = function() {

	var nowdate = new Date();

	var year = nowdate.getFullYear(),

		month = nowdate.getMonth() + 1,

		date = nowdate.getDate(),

		day = nowdate.getDay(),

		h = nowdate.getHours(),

		m = nowdate.getMinutes(),

		s = nowdate.getSeconds(),

		h = checkTime(h),

		m = checkTime(m),

		s = checkTime(s);

	return year + "-" + month + "-" + date + " " + h + ":" + m + ":" + s;

}

Vue.prototype.timeAgo = function(datetime) {
	var dateTimeStamp = Date.parse(datetime.replace(/-/gi, "/"));
	var minute = 1000 * 60;
	var hour = minute * 60;
	var day = hour * 24;
	var week = day * 7;
	var halfamonth = day * 15;
	var month = day * 30;
	var now = new Date().getTime(); //获取当前时间毫秒
	var diffValue = now - dateTimeStamp; //时间差

	if (diffValue < 0) {
		return '刚刚';
	}
	var minC = diffValue / minute; //计算时间差的分，时，天，周，月
	var hourC = diffValue / hour;
	var dayC = diffValue / day;
	var weekC = diffValue / week;
	var monthC = diffValue / month;
	var result = "2";
	if (monthC >= 1 && monthC <= 3) {
		result = " " + parseInt(monthC) + "月前"
	} else if (weekC >= 1 && weekC <= 3) {
		result = " " + parseInt(weekC) + "周前"
	} else if (dayC >= 1 && dayC <= 6) {
		result = " " + parseInt(dayC) + "天前"
	} else if (hourC >= 1 && hourC <= 23) {
		result = " " + parseInt(hourC) + "小时前"
	} else if (minC >= 1 && minC <= 59) {
		result = " " + parseInt(minC) + "分钟前"
	} else if (diffValue >= 0 && diffValue <= minute) {
		result = "刚刚"
	} else {
		var datetime = new Date();
		datetime.setTime(dateTimeStamp);
		var Nyear = datetime.getFullYear(); {}
		var Nmonth = datetime.getMonth() + 1 < 10 ? "0" + (datetime.getMonth() + 1) : datetime.getMonth() + 1;
		var Ndate = datetime.getDate() < 10 ? "0" + datetime.getDate() : datetime.getDate();
		var Nhour = datetime.getHours() < 10 ? "0" + datetime.getHours() : datetime.getHours();
		var Nminute = datetime.getMinutes() < 10 ? "0" + datetime.getMinutes() : datetime.getMinutes();
		var Nsecond = datetime.getSeconds() < 10 ? "0" + datetime.getSeconds() : datetime.getSeconds();
		result = Nyear + "-" + Nmonth + "-" + Ndate
	}
	return result;
}

Vue.prototype.nFormatter = function(num) {
	const si = [{
			value: 1,
			symbol: ""
		},
		{
			value: 1E3,
			symbol: "K"
		},
		{
			value: 1E6,
			symbol: "M"
		},
		{
			value: 1E9,
			symbol: "G"
		},
		{
			value: 1E12,
			symbol: "T"
		},
		{
			value: 1E15,
			symbol: "P"
		},
		{
			value: 1E18,
			symbol: "E"
		}
	];
	const rx = /\.0+$|(\.[0-9]*[1-9])0+$/;
	let i;
	for (i = si.length - 1; i > 0; i--) {
		if (num >= si[i].value) {
			break;
		}
	}
	return (num / si[i].value).toFixed(2).replace(rx, "$1") + si[i].symbol;
}

Vue.prototype.getCurrentUserInfo = function() {
	if (!this.$store.state.token) return

	return new Promise((resolve, reject) => {
		uni.request({
			method: "post",
			url: this.$store.state.restUrlNormal + 'getUserInfo',
			header: this.$store.state.headerToken,
			success: (res) => {
				if (res.statusCode == 403 || res.data.error || res.data.data?.status == 403) {
					this.$store.commit('setToken', '')
					uni.removeStorage({
						key: 'token',
						success: (res) => {
							this.gotab('/pages/my/index')
						}
					});
				} else {
					this.$store.commit('setUserData', res.data.user_data)
					this.$store.commit('setUserRole', {
						binding_login: res.data.binding_login,
						can_img: res.data.can_img,
						can_video: res.data.can_video,
						can_file: res.data.can_file,
						carts: res.data.carts,
						create_circle: res.data.create_circle,
						create_topic: res.data.create_topic,
						distribution: res.data.distribution,
						newsflashes: res.data.newsflashes,
						write: res.data.write,
						msg_unread: res.data.msg_unread,
						dmsg_unread: res.data.dmsg_unread
					})
					resolve(res.data)
				}
			}
		});
	})
}

Vue.prototype.getSiteData = function() {
	uni.request({
		method: "POST",
		url: this.$store.state.restUrl + 'getDefaultData2',
		header: this.$store.state.headerToken,
		success: (res) => {
			if (res.statusCode == 403) {
				uni.showToast({
					title: '登录已过期，请重新登录',
					icon: 'none',
					duration: 2000
				});
				this.$store.commit('setToken', '')
				this.$store.commit('setUserData', '')
				this.$store.commit('setUserRole', '')
				this.getSiteData()
				setTimeout(() => {
					uni.reLaunch({
						url: '/pages/my/index'
					});
				}, 2000)
			} else {

				this.$store.commit('setOpt', res.data)

				//index 是从左边算起那一个 ，计数从0开始。比如要修改第3个菜单，那么index 就是 2
				uni.setTabBarItem({
					index: 1,
					text: this.$store.state.opt.mNames.circle_name,
					iconPath: "static/icon/donut-chart-fill.png",
					selectedIconPath: "static/icon/donut-chart-line.png"
				});

				uni.setTabBarItem({
					index: 2,
					text: this.$store.state.opt.mNames.newsflashes_name,
					iconPath: "static/icon/flashlight-line.png",
					selectedIconPath: "static/icon/flashlight-fill.png"
				});

				// uni.setTabBarItem({
				// 	index: 2,
				// 	text: this.$store.state.opt.mNames.infomation_name,
				// 	iconPath: "static/icon/flashlight-line.png",
				// 	selectedIconPath: "static/icon/flashlight-fill.png"
				// });

				uni.setTabBarItem({
					index: 3,
					text: this.$store.state.opt.mNames.shop_name,
					iconPath: "static/icon/shopping-bag-line.png",
					selectedIconPath: "static/icon/shopping-bag-fill.png"
				});

			}
		},
		fail: (res) => {}
	});
}


Vue.prototype.b2add = function(arg1, arg2) {
	arg1 = arg1.toString(), arg2 = arg2.toString();
	var arg1Arr = arg1.split("."),
		arg2Arr = arg2.split("."),
		d1 = arg1Arr.length == 2 ? arg1Arr[1] : "",
		d2 = arg2Arr.length == 2 ? arg2Arr[1] : "";
	var maxLen = Math.max(d1.length, d2.length);
	var m = Math.pow(10, maxLen);
	var result = Number(((arg1 * m + arg2 * m) / m).toFixed(maxLen));
	var d = arguments[2];
	return typeof d === "number" ? Number((result).toFixed(d)) : result;
}

Vue.prototype.b2sub = function(arg1, arg2) {
	return this.b2add(arg1, -Number(arg2), arguments[2]);
}

Vue.prototype.b2mul = function(arg1, arg2) {
	var r1 = arg1.toString(),
		r2 = arg2.toString(),
		m, resultVal, d = arguments[2];
	m = (r1.split(".")[1] ? r1.split(".")[1].length : 0) + (r2.split(".")[1] ? r2.split(".")[1].length : 0);
	resultVal = Number(r1.replace(".", "")) * Number(r2.replace(".", "")) / Math.pow(10, m);
	return typeof d !== "number" ? Number(resultVal) : Number(resultVal.toFixed(parseInt(d)));
}

Vue.prototype.b2div = function(arg1, arg2) {
	var r1 = arg1.toString(),
		r2 = arg2.toString(),
		m, resultVal, d = arguments[2];
	m = (r2.split(".")[1] ? r2.split(".")[1].length : 0) - (r1.split(".")[1] ? r1.split(".")[1].length : 0);
	resultVal = Number(r1.replace(".", "")) / Number(r2.replace(".", "")) * Math.pow(10, m);
	return typeof d !== "number" ? Number(resultVal) : Number(resultVal.toFixed(parseInt(d)));
}

Vue.prototype.b2CheckJson = function(str) {
	if (typeof str == 'string') {
		try {
			var obj = JSON.parse(str);
			if (typeof obj == 'object' && obj) {
				return true;
			} else {
				return false;
			}
		} catch (e) {
			return false;
		}
	}
	return false;
}

Vue.prototype.b2GetInnerText = function(msg) {
	var msg = msg.replace(/<\/?[^>]*>/g, ''); //去除HTML Tag
	msg = msg.replace(/[|]*\n/, ''); //去除行尾空格
	msg = msg.replace(/&npsp;/gi, ''); //去掉npsp
	return msg;
}

function b2filter(str) { // 特殊字符转义
	str += ''; // 隐式转换
	str = str.replace(/%/g, '%25');
	str = str.replace(/\+/g, '%2B');
	str = str.replace(/ /g, '%20');
	str = str.replace(/\//g, '%2F');
	str = str.replace(/\?/g, '%3F');
	str = str.replace(/&/g, '%26');
	str = str.replace(/\=/g, '%3D');
	str = str.replace(/#/g, '%23');
	return str;
}

Vue.prototype.formateObjToParamStr = function(paramObj) {
	const sdata = [];
	for (let attr in paramObj) {
		sdata.push(`${attr}=${b2filter(paramObj[attr])}`);
	}
	return sdata.join('&');
};

Vue.prototype.getInterval = function(start, end) {
	// 两个日期对象，相差的毫秒数
	var interval = end - start;
	// 求 相差的天数/小时数/分钟数/秒数
	var day, hour, minute, second;

	// 两个日期对象，相差的秒数
	// interval = interval / 1000;
	interval /= 1000;

	day = parseInt(interval / 60 / 60 / 24);
	hour = parseInt(interval / 60 / 60 % 24);
	minute = parseInt(interval / 60 % 60);
	second = parseInt(interval % 60);

	return {
		day: day,
		hour: hour,
		minute: minute,
		second: second
	}
}

Vue.prototype.$decode = function(s) {
	const HTML_DECODE = {
			"&lt;": "<",
			"&gt;": ">",
			"&amp;": "&",
			"&nbsp;": " ",
			"&quot;": "\"",
			"&copy;": "©"
		},
		REGX_HTML_ENCODE = /"|&|'|<|>|[\x00-\x20]|[\x7F-\xFF]|[\u0100-\u2700]/g,
		REGX_HTML_DECODE = /&\w+;|&#(\d+);/g;

	return (typeof s != "string") ? s :
		s.replace(REGX_HTML_DECODE,
			function($0, $1) {
				var c = REGX_HTML_ENCODE[$0]; // 尝试查表
				if (c === undefined) {
					// Maybe is Entity Number
					if (!isNaN($1)) {
						c = String.fromCharCode(($1 == 160) ? 32 : $1);
					} else {
						// Not Entity Number
						c = $0;
					}
				}
				return c;
			});
}

// #ifdef MP
Vue.prototype.$isMP = true
// #endif
// #ifndef MP
Vue.prototype.$isMP = false
// #endif

// #ifndef MP-BAIDU
Vue.prototype.$isBaidu = false
// #endif
// #ifdef MP-BAIDU
Vue.prototype.$isBaidu = true
// #endif

// #ifndef APP-PLUS
Vue.prototype.$isApp = false
// #endif
// #ifdef APP-PLUS
Vue.prototype.$isApp = true
// #endif


// #ifndef H5
Vue.prototype.$isH5 = false
// #endif
// #ifdef H5
Vue.prototype.$isH5 = true
// #endif

Vue.prototype.$vote = function(id, type) {
	return new Promise((resolve, reject) => {
		if (!this.$store.state.token) {
			go.to('/global/login')
			return
		} else {
			uni.request({
				method: "post",
				url: this.$store.state.restUrlNormal + 'postVote',
				header: this.$store.state.headerToken,
				data: {
					post_id: id,
					type: type,
				},
				success: (res) => {
					if (res.data.data?.status == 403) {
						showToast(res.data.message)
					} else {
						showToast('感谢参与！')
						resolve(res.data)
					}
				}
			});

		}
	})
}

Vue.prototype.$collection = function(id) {

	return new Promise((resolve, reject) => {
		if (!this.$store.state.token) {
			go.to('/global/login')
			return
		} else {
			uni.request({
				method: "post",
				url: this.$store.state.restUrlNormal + 'userFavorites',
				header: this.$store.state.headerToken,
				data: {
					post_id: id
				},
				success: (res) => {
					if (res.data.data?.status == 403) {
						showToast(res.data.message)
					} else {
						showToast('感谢参与！')
						resolve(res.data)
					}
				}
			});
		}
	})
}

Vue.prototype.$getCollection = function(id) {
	return new Promise((resolve, reject) => {
		uni.request({
			method: "post",
			url: this.$store.state.restUrlNormal + 'getPostFavorites',
			header: this.$store.state.headerToken,
			data: {
				post_id: id
			},
			success: (res) => {
				resolve(res.data)
			}
		});
	})
}

Vue.prototype.$getVote = function(id) {
	return new Promise((resolve, reject) => {

		uni.request({
			method: "post",
			url: this.$store.state.restUrlNormal + 'getPostVote',
			header: this.$store.state.headerToken,
			data: {
				post_id: id
			},
			success: (res) => {
				resolve(res.data)
			}
		});

	})
}

const app = new Vue({
	store,
	...App
})
app.$mount()